#include <bits/stdc++.h>
#define map unordered_map

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};
ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }
ll sqr(ll x) { return x*x; } ll sqr(int x) { return (ll)x*x; }
double sqr(double x) { return x*x; } ld sqr(ld x) { return x*x; }

// ========================================================================= //

const int N = 1 << 17;

int mget(const map < int , int > & m, int x)
{
	auto it = m.find(x);
	if (it == m.end())
		return x;
	return it->second;
}

class SegTree
{
	map < int , int > t[N*2-1], tr[N*2-1];
public:
	int get(int i, int r, int c = 0, int cl = 0, int cr = N - 1)
	{
		if (cl > r)
			return i;
		if (cr <= r)
			return mget(t[c], i);
		return get(get(i, r, c*2+1, cl, (cl+cr)/2), r, c*2+2, (cl+cr)/2+1, cr);
	}

	ipair makeSwap(int p, int x, int y, int c = 0, int cl = 0, int cr = N - 1)
	{
		auto & s = t[c];
		auto & sr = tr[c];
		if (cl == cr)
		{
			int fx = mget(s, x);
			int fy = mget(s, y);
			s[x] = fy; s[y] = fx;
			sr[fx] = y; sr[fy] = x;
			return {x, y};
		}
		int mid = (cl + cr) / 2;
		if (p <= mid)
		{
			auto pp = makeSwap(p, x, y, c*2+1, cl, mid);
			x = pp.X;
			y = pp.Y;
		} else {
			auto pp = makeSwap(p, x, y, c*2+2, mid+1, cr);
			x = pp.X;
			y = pp.Y;
			auto & s1r = tr[c*2+1];
			x = mget(s1r, x);
			y = mget(s1r, y);
		}
		auto & s1 = t[c*2+1];
		auto & s2 = t[c*2+2];
		sr[s[x] = mget(s2, mget(s1, x))] = x;
		sr[s[y] = mget(s2, mget(s1, y))] = y;
		return {x, y};
	}
} st;

int n, m, q;

int main()
{
#ifndef LOCAL
	freopen("conveyor.in", "r", stdin);
	freopen("conveyor.out", "w", stdout);
#endif
    ios::sync_with_stdio(false);

	scanf("%d%d%d", &n, &m, &q);
	for (int ijk = 0; ijk < q; ++ijk)
	{
		int t;
		scanf("%d", &t);
		if (t)
		{
			int i, c;
			scanf("%d%d", &i, &c);
			--i;
			--c;
			cout << st.get(i, c) + 1 << "\n";
		} else {
			int x, y, c;
			scanf("%d%d%d", &x, &y, &c);
			--x;
			--y;
			--c;
			st.makeSwap(c, x, y);
		}
	}

    return 0;
}

