#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};
ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }
ll sqr(ll x) { return x*x; } ll sqr(int x) { return (ll)x*x; }
double sqr(double x) { return x*x; } ld sqr(ld x) { return x*x; }

// ========================================================================= //

const int N = 200179;

int n;
vector < int > e[N];
int p[N], dep[N];
int m, qx[N], qy[N];

void dfs(int v, int cp, int cdep)
{
	dep[v] = cdep;
	p[v] = cp;
	for (int nv : e[v])
		if (nv != cp)
			dfs(nv, v, cdep + 1);
}

int main()
{
#ifndef LOCAL
	freopen("paths.in", "r", stdin);
	freopen("paths.out", "w", stdout);
#endif
	scanf("%d", &n);
	assert(n <= 200);
	for (int i = 0; i < n - 1; ++i)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		--y;
		e[x].push_back(y);
		e[y].push_back(x);
	}

	int m;
	scanf("%d", &m);
	assert(m <= 200);
	for (int i = 0; i < m; ++i)
	{
		scanf("%d%d", qx + i, qy + i);
		--qx[i];
		--qy[i];
	}

	int ans = -1;
	for (int i = 0; i < n; ++i)
	{
		dfs(i, -1, 0);
		int cans = 0;
		for (int j = 0; j < m; ++j)
		{
			int x = qx[j];
			int y = qy[j];
			if (dep[x] < dep[y])
				swap(x, y);
			while (dep[x] > dep[y])
				x = p[x];
			cans += (x == y);
		}
		ans = max(ans, cans);
	}
	cout << ans << "\n";

    return 0;
}

