#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};
ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }
ll sqr(ll x) { return x*x; } ll sqr(int x) { return (ll)x*x; }
double sqr(double x) { return x*x; } ld sqr(ld x) { return x*x; }

// ========================================================================= //

const int D = 18;
const int N = 200179;

int n;
vector < int > e[N];
int dp[D][N];
int dep[N];
int add[N];

void dfs(int v, int p, int cdep)
{
	dep[v] = cdep;
	dp[0][v] = p;
	for (int i = 1; i < D; ++i)
		dp[i][v] = (dp[i-1][v] == -1 ? -1 : dp[i-1][dp[i-1][v]]);
	for (int i = 0; i < sz(e[v]); ++i)
	{
		int nv = e[v][i];
		if (nv == p)
		{
			e[v][i] = e[v].back();
			e[v].pop_back();
			--i;
			continue;
		}
		dfs(nv, v, cdep + 1);
	}
}

int goUp(int x, int p)
{
	for (int i = D - 1; i >= 0; --i)
		if (p >= (1 << i))
		{
			x = dp[i][x];
			p -= (1 << i);
		}
	return x;
}

int ans = -1;

void dfs1(int v, int c)
{
	ans = max(ans, c += add[v]);
	for (int nv : e[v])
		dfs1(nv, c);
}

int main()
{
#ifndef LOCAL
	freopen("paths.in", "r", stdin);
	freopen("paths.out", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 0; i < n - 1; ++i)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		--y;
		e[x].push_back(y);
		e[y].push_back(x);
	}
	dfs(0, -1, 0);

	int m;
	scanf("%d", &m);
	for (int i = 0; i < m; ++i)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		--y;
		if (dep[x] < dep[y])
			swap(x, y);
		add[x] += 1;
		int x1 = goUp(x, dep[x] - dep[y] - 1);
		if (dp[0][x1] != y)
			add[y] += 1;
		else
		{
			add[0] += 1;
			add[x1] -= 1;
		}
	}

	dfs1(0, 0);
	cout << ans << "\n";

    return 0;
}

