#include "testlib.h"
#include <string>
using namespace std;

template<typename T>
string to_string(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}

const int MAXN = 1e5;
const int MAXX = 1000;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(2, MAXN, "Incorrect n");
    inf.readEoln();
    for (int i = 0; i < n; i++)
    {
        inf.readInt(1, MAXX, "Incorrect a[" + to_string(i + 1) + "]");
        if (i < n - 1)
            inf.readSpace();
    }
    inf.readEoln();
    inf.readEof();

    return 0;
}