/**
 *    author:  [itmo] enot.1.10
 *    created: 11.02.2017 11:51:21       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

#define TASK "sum"

const int N = 1e5 + 10;

int a[N];


int main()
{
    assert(freopen(TASK".in", "r", stdin));
    assert(freopen(TASK".out", "w", stdout));
    int n;
    scanf("%d", &n);
    forn(i, n) scanf("%d", &a[i]);
    int mx = 0;
    int mn = 1000;
    int res = 0;
    for (int i = 1; i < n; i += 2)
    {
        mx = max(mx, a[i]);
        res -= a[i];
    }
    for (int i = 0; i < n; i += 2)
    {
        mn = min(mn, a[i]);
        res += a[i];
    }
    if (mx > mn) res += 2 * (mx - mn);
    printf("%d\n", res);
    #ifdef home
        eprintf("Time: %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
